class "Level"{
    x_pos   =   0,
    y_pos   =   0,
    state   =   ""
}

function Level:__init__(filename, p_world)
    assert( filename ~= nil )
    -- load table from file
    local info,err = table.load( filename )
    assert( err == nil )
    -- TODO: change this to take the one in the level
    info.imagename  =   info.imagename:match("([^/]+)$") or info.imagename
    self.image  =   love.graphics.newImage("res/images/level/"..info.imagename)
    self.y_pos  =   0
    self.x_pos  =   0

    --If a world is passed, we go for a physics simulation
    if p_world then
        self.world  =   p_world
        levelshape  =   love.physics.newChainShape( false, unpack(info.collidable) )
        levelbody   =   love.physics.newBody(p_world, 0,0, "static")
        levelfixt   =   love.physics.newFixture(levelbody, levelshape)
    end
end

function Level:update(p_dt)
    --~ TODO:Ground:update
end

function Level:getDrawable()
    return self.image, self.x_pos, self.y_pos
end
