-- Util class Rectangle to keep track of coordinates and make quick tests

class "Rectangle"{
}

function Rectangle:__init__(p_x, p_y, p_width, p_height)
    assert(p_x, "missing parameter")
    assert(p_y, "missing parameter")
    assert(p_width, "missing parameter")
    assert(p_height, "missing parameter")

    self.x=p_x
    self.y=p_y
    self.width=p_width
    self.height=p_height

    self.center_x=self.x + self.width  / 2
    self.center_y=self.y + self.height / 2

end

function Rectangle:contains(p_x, p_y)
    local x_ok=false
    local y_ok=false
    if p_x > self.x and p_x < self.x + self.width then
        x_ok=true
    end
    if p_y > self.y and p_y < self.y + self.height then
        y_ok=true
    end
    return (x_ok and y_ok)

end

function Rectangle:getCenter()
    return self.center_x, self.center_y

end

function Rectangle:inflate(p_width, p_height)
    self.x      = self.x - p_width      / 2
    self.width  = self.width + p_width  / 2
    self.y      = self.y - p_height     / 2
    self.height = self.height + p_height/ 2

end
