require "lib.slither"
require "lib.resource_loader"
require "class.Seed"
require "class.Core"
require "class.Config"
require "class.Rectangle"
require "class.Button"
require "class.Level"


require "data.i18n.translator"
require "data.i18n.fr"
Gamestate = require "lib.hump.gamestate"
ringbuffer= require "lib.hump.ringbuffer"
camera    = require "lib.hump.camera"
vector    = require "lib.hump.vector"

dofile("lib/table.save.lua")
require "menu_gamestates"
require "play_gamestates"

APP_NAME        =   "Seed"
PROJECT_VERSION =   " alpha 0.0.1"


function love.load()
    -- Init gamestates and display
    Gamestate.registerEvents()
    print(APP_NAME..PROJECT_VERSION)
    love.graphics.setCaption(APP_NAME..PROJECT_VERSION)
    GAMECONFIG      =   Config()
    setLocale(GAMECONFIG.options["locale"])

    -- Record the gametime
    gametime        =   0


    -- Loading fonts
    title_font      =   love.graphics.newFont("res/fonts/Varling.ttf", 89)
    big_font        =   love.graphics.newFont("res/fonts/Varling.ttf", 42)
    standard_font   =   love.graphics.newFont("res/fonts/Varling.ttf", 24)
    love.graphics.setFont(standard_font)


    -- Loading species
    load_species()

    --Switching to default mode: newgame
    Gamestate.switch(splashscreen)



end

function love.draw()
    -- TODO: default font too
    love.graphics.setColor(255, 255, 255)

end

function love.update(dt)
    gametime    =   gametime + dt

end

function love.quit()
  print("Played "..gametime.." seconds, leaving game...")

end

-- Util function to recursively print userdata
function tprint (tbl, indent)
  if not indent then indent = 0 end
  for k, v in pairs(tbl) do
    formatting = string.rep("  ", indent) .. k .. ": "
    if type(v) == "table" then
      print(formatting)
      tprint(v, indent+1)
    else
      print(tostring(formatting) .. tostring(v))
    end
  end
end
